// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysax.h 716 2010-08-01 21:12:15Z fancylibs $
**
** Licensed under the MPL 2.0
**
** Author: Wolfgang Glas / EV-i
**
** ABI macros for fancysax.
**
*****************************************************************************/

#ifndef FANCYSAX_H
#define FANCYSAX_H

#ifdef WIN32
# ifdef __GNUC__
#  ifdef BUILD_fancysax_DLL
#   define FANCYSAX_API __attribute__((dllexport))
#  else
#   define FANCYSAX_API __attribute__((dllimport))
#  endif
# else
#  ifdef BUILD_fancysax_DLL
#   define FANCYSAX_API __declspec(dllexport)
#  else
#   define FANCYSAX_API __declspec(dllimport)
#  endif
# endif
#else
# ifdef __GNUC__
#  define FANCYSAX_INTERNAL_API __attribute__((visibility("hidden")))
# endif
#endif

#ifndef FANCYSAX_INTERNAL_API
#define FANCYSAX_INTERNAL_API
#endif

#ifndef FANCYSAX_API
#define FANCYSAX_API
#endif

namespace Fancy {
namespace SAX {

/**
 * A SAX Attribute as reported by @c ContentHandler::startElementNs().
 */
struct FANCYSAX_API Attribute {

    const char *localname; //! The name of the attribute without namespace prefix
    const char *prefix;    //! The namespace prefix of the attribute.
    const char *URI;       //! The namespace URI of the attribute.
    const char *value;     //! The value of the attribute. The value is not null terminated,
    const char *end;       //! The end of the value of the attribute in memory.

    /**
     * @return The length of value in memory, aka @c end-value.
     */
    int valueLength() const { return this->end-this->value; }
};

}}

#endif
