// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysaxexception.h 691 2010-07-28 09:31:48Z fancylibs $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** SAX parser exceptions.
** 
*****************************************************************************/

#ifndef FANCYSAX_EXCEPTION_H
#define FANCYSAX_EXCEPTION_H

#include <fancysax.h>
#include <fancyexception.h>

namespace Fancy {
  namespace SAX {

    class FANCYSAX_API Exception : public Fancy::Exception
    {
    public:
      Exception (int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
;

      Exception (fancylog_service *service,
                 int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,5,6)))
#endif
;

      virtual ~Exception() throw();

    protected:
      Exception (fancylog_service *service,
                 int facility,
                 int priority ) throw();
    };

  }
}

#endif
