// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysaxlog.h 818 2010-09-08 20:43:13Z fancylibs $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global logging stuff.
** 
*****************************************************************************/

#ifndef FANCYSAX_LOG_H
#define FANCYSAX_LOG_H

#include <fancysax.h>
#include <fancylog.h>

// facility masks:
// facility "fancysaxparser"
#define  FANCYSAX_LOG_PARSER          (1<<0)
// facility "fancysaxcontenthandler"
#define  FANCYSAX_LOG_CONTENT_HANDLER (1<<1)
// facility "fancysaxdtdhandler"
#define  FANCYSAX_LOG_DTD_HANDLER     (1<<2)

namespace Fancy {
  namespace SAX {

    extern FANCYSAX_API fancylog_service *log_service;

    // parse for logging cmdline args and filter out recognized options.
    void FANCYSAX_API fancylog_parse_arg (int *argc, char **argv);

    inline void vfancylog (int facility,
                           int priority, const char *fmt, va_list ap)
      {
        va_list aq;
        va_copy(aq,ap);
        ::vfancylog(log_service,facility,priority,fmt,aq);
        va_end(aq);
      }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));
    
#endif

    inline void fancylog (int facility,
                          int priority, const char *fmt, ...)
      {
        va_list ap;
        va_start(ap, fmt);
        vfancylog(facility,priority,fmt,ap);
        va_end(ap);
      }
  }
}

#endif // ! FANCYSAX_LOG_H
