/*
 * fancysaxsimplecontenthandler.h
 *
 *  Created on: 28.07.2010
 *      Author: wglas
 */

#ifndef FANCYSAXSIMPLECONTENTHANDLER_H_
#define FANCYSAXSIMPLECONTENTHANDLER_H_

#include <fancysaxcontenthandler.h>

namespace Fancy {

class List;

namespace SAX {

class TagHandler;

class FANCYSAX_API SimpleContentHandler: public virtual Fancy::SAX::ContentHandler {

    Fancy::ObjPtr<Fancy::List> handlers;
    Fancy::ObjPtr<TagHandler> rootHandler;

public:
    typedef Fancy::ObjPtr<SimpleContentHandler> ptr_t;

    /**
     * Instantiate a new simple content handler with a given handler for
     * the document element.
     *
     * @return A new simple content handler instance.
     */
    static ptr_t newInstance(const Fancy::ObjPtr<TagHandler> &rootHandler);

    /**
     * @overload
     */
    virtual void startElementNs (const char * localname,
                                 const char * prefix,
                                 const char * URI,
                                 int nb_namespaces,
                                 const char ** namespaces,
                                 int nb_attributes,
                                 int nb_defaulted,
                                 const Attribute* attributes);

    /**
     * @overload
     */
    virtual void endElementNs (const char * localname,
                               const char * prefix,
                               const char * URI);

    /**
     * @overload
     */
    virtual void characters (const char *ch,
                             int len);

    /**
     * @overload
     */
    virtual void startDocument ();

    /**
     * @overload
     */
    virtual void endDocument ();

protected:
    SimpleContentHandler(const Fancy::ObjPtr<TagHandler> &rootHandler);
    virtual ~SimpleContentHandler();
};

}

}

#endif /* FANCYSAXSIMPLECONTENTHANDLER_H_ */
